VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Currency Exchange Rates"
   ClientHeight    =   4905
   ClientLeft      =   1200
   ClientTop       =   615
   ClientWidth     =   6900
   Height          =   5310
   Left            =   1140
   LinkTopic       =   "Form1"
   ScaleHeight     =   4905
   ScaleWidth      =   6900
   Top             =   270
   Width           =   7020
   Begin VB.CommandButton butStop 
      Caption         =   "&Stop"
      Height          =   375
      Left            =   3120
      TabIndex        =   4
      Top             =   1560
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   9.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   1335
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Text            =   "CURR.frx":0000
      Top             =   120
      Width           =   6015
   End
   Begin VB.CommandButton butGo 
      Caption         =   "&Get All"
      Height          =   375
      Left            =   1440
      TabIndex        =   1
      Top             =   1560
      Width           =   1215
   End
   Begin VBX.SpreadSheet Spread1 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   2055
      InterfaceDesigner=   "CURR.frx":0006
      Left            =   120
      MaxCols         =   5
      MaxRows         =   5
      TabIndex        =   0
      Top             =   2040
      Width           =   6135
   End
   Begin VBX.dsSocket dsSocket1 
      DataSize        =   2048
      EOLChar         =   0
      Left            =   5880
      LineMode        =   0   'False
      Linger          =   0   'False
      LocalPort       =   80
      RemoteDotAddr   =   ""
      RemoteHost      =   "www.dna.lth.se/cgi-bin/kurt/rates"
      RemotePort      =   80
      ServiceName     =   "www"
      Timeout         =   10
      Top             =   1560
   End
   Begin Threed.SSPanel HelpLine 
      Align           =   2  'Align Bottom
      Height          =   525
      Left            =   0
      TabIndex        =   3
      Top             =   4380
      Width           =   6900
      _version        =   65536
      _extentx        =   12171
      _extenty        =   926
      _stockprops     =   15
      backcolor       =   12632256
      BeginProperty font {FB8F0823-0164-101B-84ED-08002B2EC713} 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   12
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      bevelinner      =   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
Private nConnected As Boolean
Private nStop As Boolean
Private szHTML As String
Private Function ParseResponse(szResp$, Item%) As Variant
Select Case Item
Case 0  'date
    ParseResponse = Mid(ParseString(szResp, "As of", 2), 5, 11)
Case 1  'from
    ParseResponse = Left(ParseString(szResp, ":", 5), 11)
Case 2  'to
    ParseResponse = Left(ParseString(szResp, ":", 7), 11)
End Select
End Function
Private Function szGetHTML(szHost$, szGet$) As String
dsSocket1.RemoteHost = szHost$
dsSocket1.RemotePort = 80
On Error Resume Next
dsSocket1.Action = 2
If Err Then
    MsgBox Error$
Else
    nConnected = False
    Do
        DoEvents
    Loop Until nConnected Or nStop
    szHTML = ""
    dsSocket1.Send = szGet & vbCrLf
    HelpLine = "Send " & szGet
    Do
        DoEvents
    Loop Until (nConnected = False) Or nStop
    szGetHTML = szStripHTML(szHTML)
End If
End Function
Private Function szStripHTML(szString As String) As String

    Dim szTemp As String
    Dim szResult As String
    Dim nPos As Integer
    Dim nMarker As Integer

    '-- Copy the argument into a local
    '   string so the original does not
    '   get whacked.
    szTemp = szString

    '-- Remove HTML codes
    Do
        nPos = InStr(szTemp, "<")
        If nPos = False Then
            Exit Do
        Else
            '-- szResult contains the final
            '   product of this routine.
            szResult = szResult & _
                Left$(szTemp, nPos - 1)
            '-- szTemp is the working string,
            '   which is continuously
            '   shortened as new codes
            '   are found
            szTemp = Mid$(szTemp, nPos + 1)
            nPos = InStr(szTemp, ">")
            If nPos = False Then
                '-- No complimentary arrow
                '   was found.
                Exit Do
            Else
                '-- Shorten the working
                '   string
                szTemp = Mid$(szTemp, _
                    nPos + 1)
            End If
        End If
    Loop

    '-- Find a marker byte by looking for
    '   a char that does not already exist
    '   in the string.
    For nMarker = 255 To 1 Step -1
        If InStr(szResult, Chr$(nMarker)) _
            = 0 Then
            Exit For
        End If
    Next

    '-- Remove carriage returns
    Do
        nPos = InStr(szResult, Chr$(13))
        If nPos Then
            szResult = Left$(szResult, _
                nPos - 1) & Mid$(szResult, _
                nPos + 1)
        Else
            Exit Do
        End If
    Loop

    '-- Replace linefeeds with Marker bytes
    Do
        nPos = InStr(szResult, Chr$(10))
        If nPos Then
            szResult = Left$(szResult, _
                nPos - 1) & Chr$(nMarker) _
                & Mid$(szResult, nPos + 1)
        Else
            Exit Do
        End If
    Loop

    '-- Replace marker bytes with CR/LF pairs
    Do
        nPos = InStr(szResult, Chr$(nMarker))
        If nPos Then
            szResult = Left$(szResult, _
                nPos - 1) & Chr$(13) & Chr$(10) _
                & Trim$(Mid$(szResult, nPos + 1))
        Else
            Exit Do
        End If
    Loop

    '-- Thats all for this routine!
    szStripHTML = szResult

End Function

Private Sub butGo_Click()
'get all
Dim col&, row&, MaxRow&
MaxRow = 1
For col = 2 To 5
    For row = 1 To MaxRow
        Spread1_DblClick col, row
    Next
    MaxRow = MaxRow + 1
Next

End Sub

Private Sub butStop_Click()
    nStop = True
End Sub

Private Sub dsSocket1_Close(ErrorCode As Integer, ErrorDesc As String)
nConnected = False
HelpLine = "Closed"
End Sub

Private Sub dsSocket1_Connect()
nConnected = True
HelpLine = "Connected"
End Sub

Private Sub dsSocket1_Receive(ReceiveData As String)
szHTML = szHTML & ReceiveData
HelpLine = "Receive: " & szHTML
End Sub

Private Sub Spread1_DblClick(col As Long, row As Long)
'get the row and col header
Dim szHost$, szGet$
Dim C1 As Variant, C2 As Variant, i%
Spread1.row = row
Spread1.col = 0
C1 = Spread1.Text
Spread1.row = 0
Spread1.col = col
C2 = Spread1.Text
'built query
    szHost = "www.dna.lth.se"
    szGet = "GET /cgi-bin/kurt/rates?" & C1 & "+" & C2
'connect and send get
    Text1 = szGetHTML(szHost, szGet)
    SpreadSetText Spread1, 0, 0, ParseResponse(Text1, 0)
    SpreadSetText Spread1, col, row, ParseResponse(Text1, 1)
    SpreadSetText Spread1, row, col, ParseResponse(Text1, 2)

'receive and build response
'on close parse and update
End Sub
