'==========================================================================
'Copyright (c) 1992-1995, SunOpTech, Inc., All Rights Reserved
'
'       Program Name: SPREAD.BAS
'Program Description: Spread/VBX declarations - local version
'
'             Author: Stan Schultes
'       Date Created: June 13, 1995
'
'      Revision History
'   Who     Date    Comment
'   SJS   06/22/95  Eliminate temp routine SprSetText - no longer needed.
'                   Simply change the name to SpreadSetText to use std routine.
'
'Discussion:
'   Uncomment declarations as they're required
'
'===========================================================================

Global lpVarg As Variant            'for SpreadGet/Set

'Declarations from VB\SPREAD21\VB_CONST.TXT
'
'function prototypes
Declare Function SpreadGetDataFillData Lib "Spread20.vbx" (SS As Control, Var As Variant, ByVal VType As Integer) As Integer
Declare Function SpreadSetDataFillData Lib "Spread20.vbx" (SS As Control, Var As Variant) As Integer
'Declare Function SpreadSaveTabFile Lib "Spread20.vbx" (SS As Control, ByVal FileName As String) As Integer
'Declare Function SpreadSetCellDirtyFlag Lib "Spread20.vbx" (SS As Control, ByVal Col As Long, ByVal Row As Long, ByVal Dirty As Integer) As Integer
'Declare Function SpreadGetCellDirtyFlag Lib "Spread20.vbx" (SS As Control, ByVal Col As Long, ByVal Row As Long) As Integer
'Declare Function SpreadGetMultiSelItem Lib "Spread20.vbx" (SS As Control, ByVal SelPrev As Long) As Long

Declare Function SpreadAddCustomFunction Lib "Spread20.vbx" (hCtl As Control, ByVal lpszFunctionName As String, ByVal nParameterCnt As Integer) As Integer
'Declare Function SpreadCFGetDoubleParam Lib "Spread20.vbx" (hCtl As Control, ByVal dParam As Integer) As Double
'Declare Function SpreadCFGetLongParam Lib "Spread20.vbx" (hCtl As Control, ByVal dParam As Integer) As Long
'Declare Function SpreadCFGetParamInfo Lib "Spread20.vbx" (hCtl As Control, ByVal dParam As Integer, wType As Integer, wStatus As Integer) As Integer
'Declare Function SpreadCFGetStringParam Lib "Spread20.vbx" (hCtl As Control, ByVal dParam As Integer) As String
'Declare Sub SpreadCFSetResult Lib "Spread20.vbx" (hCtl As Control, Var As Variant)
'Declare Function SpreadColNumberToLetter Lib "Spread20.VBX" (ByVal lHeaderNumber As Long) As String
'Declare Sub SpreadColWidthToTwips Lib "Spread20.VBX" (SS As Control, ByVal fColWidth As Single, lpTwips As Long)
'Declare Sub SpreadGetBottomRightCell Lib "Spread20.VBX" (SS As Control, lpCol As Long, lpRow As Long)
'Declare Sub SpreadGetCellFromScreenCoord Lib "Spread20.VBX" (SS As Control, lpCol As Long, lpRow As Long, ByVal x As Long, ByVal y As Long)
'Declare Function SpreadGetCellPos Lib "Spread20.VBX" (SS As Control, ByVal Col As Long, ByVal Row As Long, lpx As Long, lpy As Long, lpWidth As Long, lpHeight As Long) As Integer
'Declare Sub SpreadGetClientArea Lib "Spread20.VBX" (SS As Control, lplWidth As Long, lplHeight As Long)
'Declare Function SpreadGetColItemData Lib "Spread20.VBX" (SS As Control, ByVal Col As Long) As Long
'Declare Sub SpreadGetFirstValidCell Lib "Spread20.VBX" (SS As Control, lpCol As Long, lpRow As Long)
'Declare Function SpreadGetItemData Lib "Spread20.VBX" (SS As Control) As Long
'Declare Sub SpreadGetLastValidCell Lib "Spread20.VBX" (SS As Control, lpCol As Long, lpRow As Long)
Declare Function SpreadGetRowItemData Lib "Spread20.VBX" (SS As Control, ByVal Row As Long) As Long
Declare Function SpreadGetText Lib "Spread20.vbx" (SS As Control, ByVal Col As Long, ByVal Row As Long, Var As Variant) As Integer
'Declare Function SpreadIsCellSelected Lib "Spread20.VBX" (SS As Control, ByVal Col As Long, ByVal Row As Long) As Integer
'Declare Function SpreadIsFormulaValid Lib "Spread20.VBX" (SS As Control, hszFormula As String) As Integer
'Declare Function SpreadIsVisible Lib "Spread20.VBX" (SS As Control, ByVal Col As Long, ByVal Row As Long, ByVal Partial As Integer) As Integer
'Declare Sub SpreadRowHeightToTwips Lib "Spread20.VBX" (SS As Control, ByVal Row As Long, ByVal fRowHeight As Single, lpTwips As Long)
'Declare Sub SpreadSaveDesignInfo Lib "Spread20.VBX" (ByVal Their_hWnd As Integer, ByVal My_hWnd As Integer, ByVal finit As Integer)
'Declare Sub SpreadSetColItemData Lib "Spread20.VBX" (SS As Control, ByVal Col As Long, ByVal lpVar As Long)
'Declare Sub SpreadSetItemData Lib "Spread20.VBX" (SS As Control, ByVal lpVar As Long)
Declare Sub SpreadSetRowItemData Lib "Spread20.VBX" (SS As Control, ByVal Row As Long, ByVal lpVar As Long)
Declare Sub SpreadSetText Lib "Spread20.VBX" (SS As Control, ByVal Col As Long, ByVal Row As Long, lpVar As Variant)
'Declare Sub SpreadTwipsToColWidth Lib "Spread20.VBX" (SS As Control, ByVal TWIPS As Long, fColWidth As Single)
'Declare Sub SpreadTwipsToRowHeight Lib "Spread20.VBX" (SS As Control, ByVal Row As Long, ByVal TWIPS As Long, fRowHeight As Single)
'Declare Function SpreadGetDataConnectHandle Lib "Spread20.vbx" (SS As Control) As Integer
'Declare Function SpreadGetDataSelectHandle Lib "Spread20.vbx" (SS As Control) As Integer

'spreadsheet actions
Global Const SS_ACTION_ACTIVE_CELL = 0
Global Const SS_ACTION_GOTO_CELL = 1
Global Const SS_ACTION_SELECT_BLOCK = 2
Global Const SS_ACTION_CLEAR = 3
'Global Const SS_ACTION_DELETE_COL = 4
Global Const SS_ACTION_DELETE_ROW = 5
'Global Const SS_ACTION_INSERT_COL = 6
'Global Const SS_ACTION_INSERT_ROW = 7
Global Const SS_ACTION_LOAD_SPREAD_SHEET = 8
Global Const SS_ACTION_SAVE_ALL = 9
'Global Const SS_ACTION_SAVE_VALUES = 10
Global Const SS_ACTION_RECALC = 11
Global Const SS_ACTION_CLEAR_TEXT = 12
Global Const SS_ACTION_PRINT = 13
Global Const SS_ACTION_DESELECT_BLOCK = 14
'Global Const SS_ACTION_DSAVE = 15
'Global Const SS_ACTION_SET_CELL_BORDER = 16
'Global Const SS_ACTION_ADD_MULTISELBLOCK = 17
'Global Const SS_ACTION_GET_MULTI_SELECTION = 18
'Global Const SS_ACTION_COPY_RANGE = 19
'Global Const SS_ACTION_MOVE_RANGE = 20
'Global Const SS_ACTION_SWAP_RANGE = 21
'Global Const SS_ACTION_CLIPBOARD_COPY = 22
'Global Const SS_ACTION_CLIPBOARD_CUT = 23
'Global Const SS_ACTION_CLIPBOARD_PASTE = 24
Global Const SS_ACTION_SORT = 25
'Global Const SS_ACTION_COMBO_CLEAR = 26
'Global Const SS_ACTION_COMBO_REMOVE = 27
'Global Const SS_ACTION_RESET = 28
'Global Const SS_ACTION_SS_ACTION_SEL_MODE_CLEAR = 29
'Global Const SS_ACTION_VMODE_REFRESH = 30
'Global Const SS_ACTION_REFRESH_BOUND = 31
'Global Const SS_ACTION_SMARTPRINT = 32

'SelectBlockOptions
'Global Const SS_SELBLOCKOPT_COLS = 1
Global Const SS_SELBLOCKOPT_ROWS = 2
'Global Const SS_SELBLOCKOPT_BLOCKS = 4
'Global Const SS_SELBLOCKOPT_ALL = 8

'DAutoSize settings
'Global Const SS_AUTOSIZE_NONE = 0
'Global Const SS_AUTOSIZE_MAX_COL_WIDTH = 1
'Global Const SS_AUTOSIZE_BEST_GUESS = 2

'cell type
Global Const SS_CELL_TYPE_DATE = 0
Global Const SS_CELL_TYPE_EDIT = 1
Global Const SS_CELL_TYPE_FLOAT = 2
Global Const SS_CELL_TYPE_INTEGER = 3
'Global Const SS_CELL_TYPE_PIC = 4
Global Const SS_CELL_TYPE_STATIC_TEXT = 5
'Global Const SS_CELL_TYPE_TIME = 6
Global Const SS_CELL_TYPE_BUTTON = 7
Global Const SS_CELL_TYPE_COMBOBOX = 8
'Global Const SS_CELL_TYPE_PICTURE = 9
'Global Const SS_CELL_TYPE_CHECKBOX = 10
'Global Const SS_CELL_TYPE_OWNER_DRAWN = 11

'cell border types
'Global Const SS_BORDER_TYPE_NONE = 0
'Global Const SS_BORDER_TYPE_OUTLINE = 16
'Global Const SS_BORDER_TYPE_LEFT = 1
'Global Const SS_BORDER_TYPE_RIGHT = 2
'Global Const SS_BORDER_TYPE_TOP = 4
'Global Const SS_BORDER_TYPE_BOTTOM = 8

'cell border style
'Global Const SS_BORDER_STYLE_DEFAULT = 0
'Global Const SS_BORDER_STYLE_SOLID = 1
'Global Const SS_BORDER_STYLE_DASH = 2
'Global Const SS_BORDER_STYLE_DOT = 3
'Global Const SS_BORDER_STYLE_DASH_DOT = 4
'Global Const SS_BORDER_STYLE_DASH_DOT_DOT = 5
'Global Const SS_BORDER_STYLE_BLANK = 6

'Bound. auto col sizing
'Global Const SS_BOUND_COL_NO_SIZE = 0
'Global Const SS_BOUND_COL_MAX_SIZE = 1
'Global Const SS_BOUND_COL_SMART_SIZE = 2

'row and column header settings
'Global Const SS_HEADER_BLANK = 0
'Global Const SS_HEADER_NUMBERS = 1
'Global Const SS_HEADER_LETTERS = 2

'check box text relative to the check box
'Global Const SS_CHECKBOX_TEXT_LEFT = 0
'Global Const SS_CHECKBOX_TEXT_RIGHT = 1

'cursorstyle
'Global Const SS_CURSOR_STYLE_USER_DEFINED = 0
'Global Const SS_CURSOR_STYLE_DEFAULT = 1
'Global Const SS_CURSOR_STYLE_ARROW = 2
'Global Const SS_CURSOR_STYLE_DEFCOLRESIZE = 3
'Global Const SS_CURSOR_STYLE_DEFROWRESIZE = 4

'cursortype
'Global Const SS_CURSOR_TYPE_DEFAULT = 0
'Global Const SS_CURSOR_TYPE_COLRESIZE = 1
'Global Const SS_CURSOR_TYPE_ROWRESIZE = 2
'Global Const SS_CURSOR_TYPE_BUTTON = 3
'Global Const SS_CURSOR_TYPE_GRAYAREA = 4
'Global Const SS_CURSOR_TYPE_LOCKEDCELL = 5
'Global Const SS_CURSOR_TYPE_COLHEADER = 6
'Global Const SS_CURSOR_TYPE_ROWHEADER = 7

'operation mode
'Global Const SS_OP_MODE_NORMAL = 0
'Global Const SS_OP_MODE_READONLY = 1
'Global Const SS_OP_MODE_ROWMODE = 2
'Global Const SS_OP_MODE_SINGLE_SELECT = 3
'Global Const SS_OP_MODE_MULTI_SELECT = 4

'sort order
'Global Const SS_SORT_ORDER_NONE = 0
Global Const SS_SORT_ORDER_ASCENDING = 1
'Global Const SS_SORT_ORDER_DESCENDING = 2

'Sort By
Global Const SS_SORT_BY_ROW = 0
'Global Const SS_SORT_BY_COL = 1

'user resize row and columns
'Global Const SS_USER_RESIZE_COL = 1
'Global Const SS_USER_RESIZE_ROW = 2

'user resize row and columns
'Global Const SS_USER_RESIZE_DEFAULT = 0
'Global Const SS_USER_RESIZE_ON = 1
'Global Const SS_USER_RESIZE_OFF = 2

'style of the virtual mode special scroll bar vscrollspecialtypes
'Global Const SS_VSCROLLSPECIAL_NO_HOME_END = 1
'Global Const SS_VSCROLLSPECIAL_NO_PAGE_UP_DOWN = 2
'Global Const SS_VSCROLLSPECIAL_NO_LINE_UP_DOWN = 4

'position settings
Global Const SS_POSITION_UPPER_LEFT = 0
'Global Const SS_POSITION_UPPER_CENTER = 1
'Global Const SS_POSITION_UPPER_RIGHT = 2
'Global Const SS_POSITION_CENTER_LEFT = 3
'Global Const SS_POSITION_CENTER_CENTER = 4
'Global Const SS_POSITION_CENTER_RIGHT = 5
Global Const SS_POSITION_BOTTOM_LEFT = 6
'Global Const SS_POSITION_BOTTOM_CENTER = 7
'Global Const SS_POSITION_BOTTOM_RIGHT = 8

'scroll bar
'Global Const SS_SCROLLBAR_NONE = 0
'Global Const SS_SCROLLBAR_H_ONLY = 1
'Global Const SS_SCROLLBAR_V_ONLY = 2
'Global Const SS_SCROLLBAR_BOTH = 3

'print type
'Global Const SS_PRINT_ALL = 0
'Global Const SS_PRINT_CELL_RANGE = 1
'Global Const SS_PRINT_CURRENT_PAGE = 2
'Global Const SS_PRINT_PAGE_RANGE = 3

'button types
'Global Const SS_CELL_BUTTON_NORMAL = 0
'Global Const SS_CELL_BUTTON_TWO_STATE = 1

'button picture align
'Global Const SS_CELL_BUTTON_ALIGN_BOTTOM = 0
'Global Const SS_CELL_BUTTON_ALIGN_TOP = 1
'Global Const SS_CELL_BUTTON_ALIGN_LEFT = 2
'Global Const SS_CELL_BUTTON_ALIGN_RIGHT = 3

'button draw mode
'Global Const SS_BDM_ALWAYS = 0
'Global Const SS_BDM_CURRENT_CELL = 1
'Global Const SS_BDM_CURRENT_COLUMN = 2
'Global Const SS_BDM_CURRENT_ROW = 4

'date formats
Global Const SS_CELL_DATE_FORMAT_DDMONYY = 0
'Global Const SS_CELL_DATE_FORMAT_DDMMYY = 1
'Global Const SS_CELL_DATE_FORMAT_MMDDYY = 2
'Global Const SS_CELL_DATE_FORMAT_YYMMDD = 3

'Edit case
'Global Const SS_CELL_EDIT_CASE_LOWER_CASE = 0
'Global Const SS_CELL_EDIT_CASE_NO_CASE = 1
'Global Const SS_CELL_EDIT_CASE_UPPER_CASE = 2

'Edit char set
'Global Const SS_CELL_EDIT_CHAR_SET_ASCII = 0
'Global Const SS_CELL_EDIT_CHAR_SET_ALPHA = 1
'Global Const SS_CELL_EDIT_CHAR_SET_ALPHANUMERIC = 2
'Global Const SS_CELL_EDIT_CHAR_SET_NUMERIC = 3

'Static text vertical alignment
'Global Const SS_CELL_STATIC_V_ALIGN_BOTTOM = 0
'Global Const SS_CELL_STATIC_V_ALIGN_CENTER = 1
'Global Const SS_CELL_STATIC_V_ALIGN_TOP = 2

'Time
'Global Const SS_CELL_TIME_12_HOUR_CLOCK = 0
'Global Const SS_CELL_TIME_24_HOUR_CLOCK = 1

'Unit type
'Global Const SS_CELL_UNIT_NORMAL = 0
'Global Const SS_CELL_UNIT_VGA = 1
Global Const SS_CELL_UNIT_TWIPS = 2

'horizontal align
Global Const SS_CELL_H_ALIGN_LEFT = 0
Global Const SS_CELL_H_ALIGN_RIGHT = 1
Global Const SS_CELL_H_ALIGN_CENTER = 2

'EditmodeAction
'Global Const SS_CELL_EDITMODE_EXIT_NONE = 0
'Global Const SS_CELL_EDITMODE_EXIT_UP = 1
'Global Const SS_CELL_EDITMODE_EXIT_DOWN = 2
'Global Const SS_CELL_EDITMODE_EXIT_LEFT = 3
'Global Const SS_CELL_EDITMODE_EXIT_RIGHT = 4
Global Const SS_CELL_EDITMODE_EXIT_NEXT = 5
'Global Const SS_CELL_EDITMODE_EXIT_PREVIOUS = 6

'Custom function parameter type
'Global Const SS_VALUE_TYPE_LONG = 0
'Global Const SS_VALUE_TYPE_DOUBLE = 1
'Global Const SS_VALUE_TYPE_STR = 2

'The return status of a custom function
'Global Const SS_VALUE_STATUS_OK = 0
'Global Const SS_VALUE_STATUS_ERROR = 1
'Global Const SS_VALUE_STATUS_EMPTY = 2
'Global Const SS_VALUE_STATUS_CLEAR = 3
'Global Const SS_VALUE_STATUS_NONE = 4

Sub ClearSpread (SS As Control)
'Clears the specified spread control

    If SS.DataRowCnt > 0 Then
        'SS.Redraw = False  'don't disable here...
        SS.BlockMode = True
        SS.Row = 1
        SS.Row2 = SS.DataRowCnt
        SS.Col = 1
        SS.Col2 = SS.DataColCnt
        SS.Action = SS_ACTION_CLEAR
        SS.BlockMode = False
        'SS.Redraw = True
    End If

End Sub

Sub SortSpread (SS As Control, Col As Long, Order As Integer)
'sorts a spread by given col in given order (ASC=1, DESC=2) CRB 1/5/95
    'add code here to resort by this column 'CRB 1/5/95
    
    'Select a block of cells
    SS.Col = -1
    SS.Row = -1
    SS.Row2 = -1
    SS.Col2 = -1

    'Specify if to sort by rows or columns
    SS.SortBy = SS_SORT_BY_ROW

    'Set sort definition for key 1
    SS.SortKey(1) = Col
    SS.SortKeyOrder(1) = Order


    'Sort the data
    SS.Action = SS_ACTION_SORT

End Sub

Sub SpreadCopy (spr As Control)
'Copy data from the spread to the clipboard

    spr.Row = spr.ActiveRow
    If spr.ActiveRow > 1 Then
        spr.Col = spr.ActiveCol
        Clipboard.SetText "" & spr.Text
        MsgBox "Copied: " & spr.Text
    Else
        spr.Row = True
        spr.Col = True
        Clipboard.SetText "" & spr.Clip
        MsgBox "Copied all!"
    End If

End Sub

Sub SpreadDateFormat (spr As Control, Col As Long, Row As Long, spin As Integer)
'Sets up the date format in specified cells
'Created 7/20/95 by SJS

spr.Col = Col
spr.Row = Row
spr.CellType = SS_CELL_TYPE_DATE
spr.TypeDateFormat = SS_CELL_DATE_FORMAT_DDMONYY
spr.TypeDateSeparator = ASCII_DASH
spr.TypeSpin = spin

End Sub

Sub SpreadLoad (fname As String, spr As Control)
'Loads a binary copy of a spreadsheet
'Created 7/18/95 by SJS

Dim Fileno As Integer

Fileno = FreeFile
Open DBPath & "\" & fname For Binary As Fileno

spr.FileNum = Fileno
spr.Row = -1
spr.Col = -1
spr.Action = SS_ACTION_LOAD_SPREAD_SHEET

Close Fileno

End Sub

Sub SpreadLock (spr As Control, Col As Long, Col2 As Long, Row As Long, Row2 As Long)
'Locks a spreadsheet range
'Created 7/20/95 by SJS

spr.Col = Col
If Col <> -1 Then spr.Col2 = Col2
spr.Row = Row
If Row <> -1 Then spr.Row2 = Row2

spr.BlockMode = True
spr.Lock = True
spr.BlockMode = False
spr.Protect = True

End Sub

Sub SpreadSaveAll (fname As String, spr As Control)
'Saves a binary copy of a spreadsheet
'Created 7/18/95 by SJS

Dim Fileno As Integer

Fileno = FreeFile
Open DBPath & "\" & fname For Binary As Fileno

spr.FileNum = Fileno
spr.Action = SS_ACTION_SAVE_ALL

Close Fileno

End Sub

Sub SpreadUnlock (spr As Control, Col As Long, Col2 As Long, Row As Long, Row2 As Long)
'UnLocks a spreadsheet range
'Created 7/20/95 by SJS

spr.Col = Col
If Col <> -1 Then spr.Col2 = Col2
spr.Row = Row
If Row <> -1 Then spr.Row2 = Row2

spr.BlockMode = True
spr.Lock = False
spr.BlockMode = False
'spr.Protect = True     'assume spread already protected

End Sub

