VERSION 4.00
Begin VB.Form frmNode 
   Caption         =   "SuperChat"
   ClientHeight    =   2145
   ClientLeft      =   2205
   ClientTop       =   3900
   ClientWidth     =   7065
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   1
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   2550
   Icon            =   "NODE.frx":0000
   Left            =   2145
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   2145
   ScaleWidth      =   7065
   Top             =   3555
   Visible         =   0   'False
   Width           =   7185
   Begin VBX.dsSocket dssNode 
      DataSize        =   2048
      EOLChar         =   0
      Left            =   240
      LineMode        =   0   'False
      Linger          =   0   'False
      LocalPort       =   0
      RemoteDotAddr   =   ""
      RemoteHost      =   ""
      RemotePort      =   0
      ServiceName     =   ""
      Timeout         =   10
      Top             =   1560
   End
   Begin VB.TextBox txtNode 
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   1
         weight          =   400
         size            =   9.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   1485
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   7095
   End
End
Attribute VB_Name = "frmNode"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Option Explicit

Private Sub dssNode_Exception(ErrorCode _
    As Integer, ErrorDesc As String)

    '-- Have we disconnected?
    If ErrorCode = SOCK_ERR_CLOSED Then
        '-- Yes
        Unload Me
    End If

End Sub

Private Sub dssNode_Receive(ReceiveData As String)
'-- We've received data!
    
    Dim nTilde As Integer
    Dim nLenName As Integer
    Dim szCallerName As String
    
    If Len(ReceiveData) > 5 Then
        '-- Is this the header?
        If Left$(ReceiveData, 5) = "NAME=" Then
            '-- Yes. Parse out the name
            nTilde = InStr(ReceiveData, "~")
            nLenName = nTilde - 6
            szCallerName = Mid$(ReceiveData, _
                6, nLenName)
            Caption = szCallerName
            If Len(ReceiveData) > nTilde Then
                ReceiveData = Mid$(ReceiveData, _
                    nTilde + 1)
            ElseIf Len(ReceiveData) = nTilde Then
                ReceiveData = ""
            End If
        End If
    End If
    
    '-- Is the receieved text getting to large?
    If Len(txtNode) > 15000 Then
        '-- Yes. Trim it off
        txtNode = Right(txtNode, 5000)
    End If
    
    '-- Set the caret to the end of the last _
        character.
    txtNode.SelStart = Len(txtNode)

    '-- Add the new text
    txtNode.SelText = ReceiveData

End Sub

Private Sub Form_Resize()
        
    '-- Resize the text box to fit the client area.
    txtNode.Width = Me.ScaleWidth
    txtNode.Height = Me.ScaleHeight

End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    '-- Close the socekt connection if
    '   its open
    On Error Resume Next
    dssNode.Action = SOCK_ACTION_CLOSE

End Sub

