VERSION 4.00
Begin VB.Form frmTerminal 
   Caption         =   "WinSock Terminal"
   ClientHeight    =   5460
   ClientLeft      =   1185
   ClientTop       =   1860
   ClientWidth     =   10500
   Height          =   6150
   Icon            =   "terminal.frx":0000
   Left            =   1125
   LinkTopic       =   "Form1"
   ScaleHeight     =   5460
   ScaleWidth      =   10500
   Top             =   1230
   Width           =   10620
   Begin VB.CheckBox chkLF 
      Caption         =   "LF"
      Height          =   285
      Left            =   7155
      TabIndex        =   9
      Top             =   4815
      Value           =   1  'Checked
      Width           =   600
   End
   Begin VB.CheckBox chkCR 
      Caption         =   "CR"
      Height          =   285
      Left            =   6525
      TabIndex        =   8
      Top             =   4815
      Value           =   1  'Checked
      Width           =   600
   End
   Begin VB.TextBox txtData 
      BeginProperty Font 
         name            =   "Courier New"
         charset         =   0
         weight          =   400
         size            =   9
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   4605
      Left            =   90
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   7
      Top             =   90
      Width           =   9015
   End
   Begin VB.CommandButton btnSend 
      Caption         =   "&Send"
      Default         =   -1  'True
      Height          =   510
      Left            =   8055
      TabIndex        =   6
      Top             =   4815
      Width           =   1100
   End
   Begin VB.TextBox txtSend 
      Height          =   330
      Left            =   585
      TabIndex        =   4
      Top             =   4815
      Width           =   5775
   End
   Begin VB.CommandButton btnClose 
      Caption         =   "&Close"
      Enabled         =   0   'False
      Height          =   510
      Left            =   9270
      TabIndex        =   3
      Top             =   1305
      Width           =   1100
   End
   Begin VB.CommandButton btnOpen 
      Caption         =   "&Open"
      Height          =   510
      Left            =   9270
      TabIndex        =   2
      Top             =   675
      Width           =   1100
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "E&xit"
      Height          =   510
      Left            =   9270
      TabIndex        =   1
      Top             =   90
      Width           =   1100
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Send:"
      Height          =   195
      Left            =   90
      TabIndex        =   5
      Top             =   4815
      Width           =   420
   End
   Begin dsSocketLib.DSSocket DSSocket1 
      Height          =   465
      Left            =   9315
      TabIndex        =   0
      Top             =   1935
      Width           =   510
      _version        =   65536
      _extentx        =   900
      _extenty        =   820
      _stockprops     =   64
      localport       =   0
      remotehost      =   ""
      remoteport      =   0
      servicename     =   ""
      remotedotaddr   =   ""
      datasize        =   1024
      linger          =   -1  'True
      timeout         =   10
      linemode        =   0   'False
      eolchar         =   10
      bindconnect     =   0   'False
   End
   Begin VB.Menu MMConnection 
      Caption         =   "&Connection"
      Begin VB.Menu MMOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu MMClose 
         Caption         =   "&Close"
         Enabled         =   0   'False
      End
      Begin VB.Menu MMDiv1 
         Caption         =   "-"
      End
      Begin VB.Menu MMExit 
         Caption         =   "&Exit"
      End
   End
End
Attribute VB_Name = "frmTerminal"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim nConnected As Integer

Const SOCK_ACTION_CLOSE = 1
Const SOCK_ACTION_CONNECT = 2

Sub btnClose_Click()

    '-- Code is behind the menu option
    MMClose_Click

End Sub



Sub btnExit_Click()
    
    '-- Code is behind the menu option
    MMExit_Click
    
End Sub


Sub btnOpen_Click()

    '-- Code is behind the menu option
    MMOpen_Click

End Sub


Sub btnSend_Click()

    Dim szSend As String
    
    '-- szSend is the actual string sent
    szSend = txtSend
    
    '-- Add a carriage return?
    If chkCR Then
        szSend = szSend & Chr$(13)
    End If
    
    '-- Add a line feed?
    If chkLF Then
        szSend = szSend & Chr$(10)
    End If

    '-- Send the text
    DSSocket1.Send = szSend

End Sub

Sub DSSocket1_Close(ErrorCode As Integer, ErrorDesc As String)

    nConnected = False
    
    Caption = "WinSock Terminal"
    
    '-- Reset menu and button enable properties
    MMClose.Enabled = False
    MMOpen.Enabled = True
    btnClose.Enabled = False
    btnOpen.Enabled = True
    
End Sub

Sub DSSocket1_Connect()
    
    nConnected = True
    
End Sub

Sub DSSocket1_Receive(ReceiveData As String)

    '-- Is there more than 10K in the display window?
    If Len(txtData) > 10000 Then
        '-- Trim off the top 5K
        txtData = Mid$(txtData, 5000)
    End If
    
    '-- Append the received text to the display window.
    txtData.SelStart = Len(txtData) + 1
    txtData.SelText = ReceiveData
    
End Sub

Sub DSSocket1_SendReady()

    nSendReady = True
    
End Sub


Sub Form_Unload(Cancel As Integer)
    
    '-- Make sure the connection is closed
    On Error Resume Next
    DSSocket1.Action = SOCK_ACTION_CLOSE
    End

End Sub

Function IsDotAddress(szAddress As String) As Integer

    '-- This function determines if a string is an IP address like
    '   199.200.199.120 or not

    Dim nPos As Integer
    Dim nIndex As Integer
    Dim szSection As String
    Dim szTemp As String

    szTemp = szAddress
    szAddress = Trim$(szAddress)

    For nIndex = 1 To 3
        nPos = InStr(szAddress, ".")
        If nPos Then
            szSection = Left$(szAddress, nPos - 1)
            If Len(szSection) = 0 Then
                Exit Function
            ElseIf Trim$(Str$(Val(szSection))) <> szSection Then
                Exit Function
            ElseIf Val(szSection) > 255 Then
                Exit Function
            ElseIf Val(szSection) < 0 Then
                Exit Function
            End If
            szAddress = Mid$(szAddress, nPos + 1)
        Else
            Exit Function
        End If
    Next

    If Len(szAddress) = 0 Then
        Exit Function
    ElseIf Trim$(Str$(Val(szAddress))) <> szAddress Then
        Exit Function
    ElseIf Val(szAddress) > 255 Then
        Exit Function
    ElseIf Val(szAddress) < 0 Then
        Exit Function
    End If

    szAddress = szTemp
    IsDotAddress = True

End Function


Sub MMClose_Click()

    '-- Make sure the connection is closed
    On Error Resume Next
    DSSocket1.Action = SOCK_ACTION_CLOSE
    
    Caption = "WinSock Terminal"
    
    '-- Reset menu and button enable properties
    MMClose.Enabled = False
    MMOpen.Enabled = True
    btnClose.Enabled = False
    btnOpen.Enabled = True
    
End Sub

Sub MMExit_Click()

    '-- The Form_Unload code closes the socket and ends.
    Unload Me

End Sub


Sub MMOpen_Click()
    
    '-- Get the host information from the user
    frmGetHost.Show 1
    
    '-- Did the user press the cancel button
    If frmGetHost.Tag = 0 Then
        Exit Sub
    End If
    
    '-- Did the user specify line mode?
    If frmGetHost.chkLineMode Then
        DSSocket1.LineMode = True
        DSSocket1.EOLChar = Val(frmGetHost.txtEOLChar)
    Else
        DSSocket1.LineMode = False
    End If
    
    '-- Make sure the socket is closed
    On Error Resume Next
    DSSocket1.Action = SOCK_ACTION_CLOSE

    '-- Set the specified port
    DSSocket1.RemotePort = Val(frmGetHost.txtPort)

    '-- Is this a DOT address or a name?
    If IsDotAddress((frmGetHost.txtHostName)) Then
        DSSocket1.RemoteDotAddr = frmGetHost.txtHostName
    Else
        DSSocket1.RemoteHost = frmGetHost.txtHostName
    End If

    '-- Attempt to Connect
    On Error Resume Next
    nConnected = False
    DSSocket1.Action = SOCK_ACTION_CONNECT
    If Err Then
        '-- Unsuccessful.
        MsgBox "Could Not Connect", vbInformation
    Else
        Do
            DoEvents
        Loop Until nConnected
        
        '-- Successful
        Caption = DSSocket1.RemoteHost & ":" & Str$(DSSocket1.RemotePort)
        
        '-- Reset menu and button enable properties
        MMClose.Enabled = True
        MMOpen.Enabled = False
        btnClose.Enabled = True
        btnOpen.Enabled = False
        
        '-- Clear the display window
        txtData = ""
    End If

End Sub


